"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getChalkMethod=void 0;
const getChalkMethod=function(key,chalk,methods){
const chalkMethod=methods.reduce(
(chalkA,{method,args,input})=>
addChalkMethod({key,chalk:chalkA,method,args,input}),
chalk);

return methodWrapper.bind(chalk,chalkMethod);
};exports.getChalkMethod=getChalkMethod;

const addChalkMethod=function({key,chalk,method,args,input}){
if(typeof chalk[method]!=="function"){
throw new TypeError(`In theme "${key}": "${input}" is not valid`);
}

const normalizeArgs=ARGS_METHODS[method];

if(normalizeArgs===undefined){
return getNoArgsChalkMethod({key,chalk,method,args});
}

return getArgsChalkMethod({args,chalk,method,normalizeArgs});
};


const getNoArgsChalkMethod=function({key,chalk,method,args}){
if(args.length!==0){
throw new TypeError(
`In theme "${key}": no arguments "${args[0]}" allowed with "${method}"`);

}

return chalk[method];
};



const getArgsChalkMethod=function({args,chalk,method,normalizeArgs}){
const argsA=normalizeChalkArgs(normalizeArgs,args);
return chalk[method](...argsA);
};

const normalizeChalkArgs=function(normalizeArgs,args){
return normalizeArgs===false?args:normalizeArgs(args);
};

const normalizeNumberArgs=function(args){
return args.map(Number);
};


const ARGS_METHODS={
hsl:normalizeNumberArgs,
bgHsl:normalizeNumberArgs,
hsv:normalizeNumberArgs,
bgHsv:normalizeNumberArgs,
hwb:normalizeNumberArgs,
bgHwb:normalizeNumberArgs,
rgb:normalizeNumberArgs,
bgRgb:normalizeNumberArgs,
hex:false,
bgHex:false,
keyword:false,
bgKeyword:false};






const methodWrapper=function(chalkMethod,string){
if(typeof string!=="string"){
throw new TypeError(`Argument must be a string, not ${string}`);
}

return chalkMethod(string);
};
//# sourceMappingURL=methods.js.map