"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getOpts=void 0;var _process=require("process");

var _filterObj=_interopRequireDefault(require("filter-obj"));
var _isPlainObj=_interopRequireDefault(require("is-plain-obj"));
var _jestValidate=require("jest-validate");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}


const getOpts=function(defaultTheme,opts={}){
validateOpts(defaultTheme,opts);
const defaultThemeA=(0,_filterObj.default)(defaultTheme,isDefined);
const optsA=(0,_filterObj.default)(opts,isDefined);
const{cwd,...colorsOptionOpts}={...getDefaultOpts(),...optsA};
return{defaultTheme:defaultThemeA,colorsOptionOpts,cwd};
};exports.getOpts=getOpts;

const validateOpts=function(defaultTheme,opts){
validateDefaultTheme(defaultTheme);
validateBasicOpts(opts);
(0,_jestValidate.validate)(opts,{exampleConfig:EXAMPLE_OPTS,recursiveDenylist:["stream"]});
};

const validateDefaultTheme=function(defaultTheme){
if(defaultTheme===undefined||!(0,_isPlainObj.default)(defaultTheme)){
throw new TypeError("The first argument must be a default theme object");
}
};

const validateBasicOpts=function(opts){
if(!(0,_isPlainObj.default)(opts)){
throw new TypeError(`Options must be a plain object: ${opts}`);
}
};

const isDefined=function(key,value){
return value!==undefined;
};

const getDefaultOpts=function(){
const cwd=(0,_process.cwd)();
return{...DEFAULT_OPTS,cwd};
};

const DEFAULT_OPTS={};

const EXAMPLE_OPTS={
...DEFAULT_OPTS,
colors:true,
stream:_process.stdout,
cwd:"/path"};
//# sourceMappingURL=options.js.map