"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.applyUserTheme=void 0;var _fs=require("fs");

var _filterObj=_interopRequireDefault(require("filter-obj"));
var _findUp=_interopRequireDefault(require("find-up"));
var _jsYaml=require("js-yaml");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}





const applyUserTheme=async function(defaultTheme,cwd){
const userTheme=await getUserTheme(cwd);
const userThemeA=(0,_filterObj.default)(
userTheme,
key=>defaultTheme[key]!==undefined);

return{...defaultTheme,...userThemeA};
};exports.applyUserTheme=applyUserTheme;

const getUserTheme=async function(cwd){
const userThemePath=await(0,_findUp.default)(USER_THEME_FILES,{cwd});

if(userThemePath===undefined){
return{};
}

const userThemeContent=await getUserThemeContent(userThemePath);
const userTheme=parseUserTheme(userThemeContent,userThemePath);
return userTheme;
};

const USER_THEME_FILES=["terminal-theme.yml","terminal-theme.yaml"];

const getUserThemeContent=async function(userThemePath){
try{
return await _fs.promises.readFile(userThemePath,"utf8");
}catch(error){
throw new Error(`Could not read "${userThemePath}"\n${error.message}`);
}
};

const parseUserTheme=function(userThemeContent,userThemePath){
try{
return(0,_jsYaml.load)(userThemeContent,{
schema:_jsYaml.JSON_SCHEMA,
json:true,
onWarning});

}catch(error){
throw new Error(`Invalid YAML in "${userThemePath}"\n${error.message}`);
}
};

const onWarning=function(error){
throw error;
};
//# sourceMappingURL=user_theme.js.map